/* ISC (c) 2018+ Jackens * https://github.com/jackens/nanolight */

if (typeof window !== 'undefined') {
  window['module.exports'] = window['module.exports'] || {}
  window.require = window.require || function (id) { return window['module.exports'][id] }
}

(function () {
  var B = /("(?:.|\n)*?")|('(?:.|\n)*?')|(`(?:.|\n)*?`)|(\/\*(?:.|\n)*?\*\/)|(<!--(?:.|\n)*?-->)|(\/\/.*?\n)/g
  var T = /(\d+(?:\.\d+)?)|(!|\$|%|&|\(|\)|\*|\+|,|-|\.|\/|:|;|<|=|>|\?|@|\[|\\|\]|\^|_|\{|\||\}|~)|([a-zA-Z_]\w+)/
  var N = 'nanolight'
  var C = N + '-char ' + N + '-char-'
  var X = '<span class="'
  var Y = '">'
  var Z = '</span>'

  function F (e, i, a, s, c) {
    if (i % 7) { return }
    s = a[i + 1] || a[i + 2] || a[i + 3]
    c = a[i + 4] || a[i + 5] || a[i + 6]
    e = I(e).split(T).map(G).join('')
    return (s ? [e, X, C, H(s), Y, s[0], Z, X, N, '-string', Y, I(s.substr(1, s.length - 2)), Z, X, C, H(s), Y, s[0], Z] : c ? [e, X, N, '-comment', Y, I(c), Z] : [e]).join('')
  }

  function G (e, i, a, n, c, w) {
    if (i % 4) { return }
    n = a[++i]
    c = a[++i]
    w = a[++i]
    e = I(e)
    return (n ? [e, X, N, '-number', Y, n, Z] : c ? [e, X, C, H(c), Y, I(c), Z] : w ? [e, X, N, '-word ', N, '-word-', w, Y, w, Z] : [e]).join('')
  }

  function H (c) {
    return c.charCodeAt(0).toString(16)
  }

  function I (e) {
    return e.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;')
  }

  var nanolight = function (code) {
    return code.split(B).map(F).join('')
  }

  nanolight.cls = function (cls) {
    var a = document.getElementsByClassName(cls || N)
    for (var i = 0; i < a.length; i++) {
      a[i].innerHTML = this(a[i].innerText)
    }
  }

  if (typeof module !== 'undefined') {
    module.exports = nanolight
  } else if (typeof window !== 'undefined') {
    window['module.exports']['nanolight'] = nanolight
  }
})()
